
#ifndef FINITEGROUP_H
#define FINITEGROUP_H
 
#include <iostream>
#include <giac/giac.h>

#include <string>
#include <map>
#include <algorithm>

using namespace std;
using namespace giac;

#include "CMfield.h"
#include "Util.h"

extern context ct;
class FiniteGroup: public CMfield
{
  public:

  FiniteGroup(string s);

  //  vector<gen> generators;
  vector<gen> elements;

  int oldnumber;
 
  bool isgroup;

  //  void addGenerator(gen M);
  //  void addGenerators(vector<gen> list);

  void addElements(vector<gen> list);
  void addElement(gen M);

  bool isNew(gen M);
  bool isInList(gen M,vector<gen> list);
  bool areMultiple(gen M, gen N);
  bool areMultipleNum(gen M, gen N, gen eps);

  void expand();
  void expandToGroup();

};

#endif
